import * as React from 'react';
export interface ModalPropsType<T> {
    title?: React.ReactNode;
    visible: boolean;
    maskClosable?: boolean;
    closable?: boolean;
    footer?: Action<T>[];
    onClose?: () => void;
    transparent?: boolean;
    popup?: boolean;
    animated?: boolean;
    animationType?: any;
    onAnimationEnd?: (visible: boolean) => void;
    animateAppear?: boolean;
    operation?: boolean;
}
export interface Action<T> {
    text: string;
    onPress?: (...args: any[]) => void | Promise<any>;
    style?: T | string;
}
export declare type Callback = (valueOrLogin: string, password?: string) => void;
export declare type CallbackOrActions<T> = Callback | Action<T>[];
